from collections import deque, defaultdict


def z(n, m, k, roads, guards):
    graph = defaultdict(list)

    for a, b in roads:
        graph[a].append(b)
        graph[b].append(a)

    guarded = set()

    for p, h in guards:
        queue = deque([(p, 0)])
        visited = set([p])

        while queue:
            current, distance = queue.popleft()
            if distance > h:
                continue
            guarded.add(current)
            for neighbor in graph[current]:
                if neighbor not in visited:
                    visited.add(neighbor)
                    queue.append((neighbor, distance + 1))

    guarded = sorted(guarded)
    return len(guarded), guarded


n, m, k = map(int, input().split())
roads = [tuple(map(int, input().split())) for _ in range(m)]
guards = [tuple(map(int, input().split())) for _ in range(k)]

count, guarded_warehouses = z(n, m, k, roads, guards)

print(count)
print(" ".join(map(str, guarded_warehouses)))